# The HoV game.
# main program by tSB
# yay

player=None

pymap=map                                   # builtin map function.  We'll use this
from std import *                           # v27 state
from constants import *
from player import Player
import hud
import powerup
import enemy
import elevator

#----------------------------------------------

def EntObs(x,y):
    # now, iterate through entities
    for e in ents:
        if e.isobs:
            if e.x<x and e.y<y and e.x+e.width>x and e.y+e.height>y:
                return e

    return None

#----------------------------------------------

def Init():
    global states,player,ents,fnt,scr,winsubx,winsuby
    states=['stand','walk','jump','fall','attack','hurt']

    hud.Init()

    player=Player()
    player.x=32
    player.y=32

    ents=[player]
    fnt=Font('speech.fnt')
    scr=GetScreenImage()
    winsubx=scr.width/2
    winsuby=scr.height/2

    input.BindKey(0x2A,6)
    input.BindKey(0x39,7)

#----------------------------------------------

def DrawScythe():
    if player.state!=state.ATTACK or player.curweapon!=weap.SCYTHE:
        return

    x=player.x-map.xwin
    y=player.y-map.ywin
    if player.dir==LEFT:
        scytheimage=player.scytheimageleft
        x-=scytheimage.width
    else:
        x+=player.width
        scytheimage=player.scytheimageright
    scytheimage.Blit(x,y)

#----------------------------------------------

def Game():
    global mapname
    mapname='stage1-1.map'

    map.Switch(mapname)

    nMaxframeskip=10

    nOldtime=GetTime()
    while 1:
        input.Update()
        map.Render()

        nFramesskipped=0

        while nOldtime<GetTime() and nFramesskipped<nMaxframeskip:
            nOldtime+=1
            ProcessEntities()

            for e in ents:
                e.Update()
                foo=e.e.DetectCollision()               # there's *a* collision
                if foo!=None:
                    for x in ents:
                        if x.e==foo:
                            x.HandleCollision(e)

                if e.killflag:
                    ents.pop(ents.index(e))
            nFramesskipped+=1

        map.xwin=player.x-winsubx+(player.width/2)
        map.ywin=player.y-winsuby+(player.height/2)
        # HACK
        DrawScythe()
        # ---
        hud.Draw()
        ShowPage()

import intro
Init()
Game()
