# "Normal" enemies

from std import *
from constants import *

from entity import Ent
from player import Player

class Enemy(Ent):
    def __init__(self,x,y):
        Ent.__init__(self,x,y)
        self.count=0
        self.mode=0

    def ProcessAI(self):
        if self.mode==0:
            self.MoveRight()
        if self.mode==1:
            self.MoveLeft()
        if self.TestHorizontal():
            self.mode^=1

class Goober(Enemy):
    def __init__(self,x=0,y=0):
        Enemy.__init__(self,x,y)

        self.CreateCHR('deflator.chr')

        self.leftanim=[
            # standing
            'Z4',
            # walking
            'Z5W20 Z6W20 Z7W20 Z6W20 B',
            # jumping
            'Z9',
            # falling
            'Z9',
            # attacking
            'Z4',
            # hurt
            'Z9'
            ]

        self.rightanim=[
            # standing
            'Z0',
            # walking
            'Z1W20 Z2W20 Z3W20 Z2W20 B',
            # jumping
            'Z8',
            # falling
            'Z8',
            # Attacking
            'Z0',
            # hurt
            'Z8'
            ]

    def HandleCollision(self,e):
        if not isinstance(e,Player):
            return      # don't care

        e.Hurt(5)

    def Hurt(self,amount):
        self.killflag=1