# Heads up display. :P

from std import *
import system

BORDERCOLOUR1=RGB(0,0,0,255)
BORDERCOLOUR2=RGB(128,128,128,255)

HEALTHBARX=4
HEALTHBARY=14
HEALTHBARWIDTH=8
HEALTHBARCOLOUR=RGB(255,0,0,128)

ENERGYBARX=20
ENERGYBARY=14
ENERGYBARWIDTH=8
ENERGYBARCOLOUR=RGB(0,0,255,128)

def Init():
    global statbar_top,statbar_bottom,scr

    statbar_top=Image()
    statbar_bottom=Image()
    statbar_top.Load('bar_top.png')
    statbar_bottom.Load('bar_bottom.png')

    scr=GetScreenImage()

def Draw():
    y2=HEALTHBARY+system.player.MAXHP-1
    y1=y2-system.player.HP
    x2=HEALTHBARX+HEALTHBARWIDTH-1
    scr.Rect(HEALTHBARX,y1,x2,y2,HEALTHBARCOLOUR,1)
    scr.Line(HEALTHBARX-1,HEALTHBARY+2,HEALTHBARX-1,y2-2,BORDERCOLOUR1)
    scr.Line(HEALTHBARX-2,HEALTHBARY+2,HEALTHBARX-2,y2-2,BORDERCOLOUR2)
    scr.Line(HEALTHBARX-3,HEALTHBARY+2,HEALTHBARX-3,y2-2,BORDERCOLOUR1)
    scr.Line(x2+1,HEALTHBARY+2,x2+1,y2-2,BORDERCOLOUR1)
    scr.Line(x2+2,HEALTHBARY+2,x2+2,y2-2,BORDERCOLOUR2)
    scr.Line(x2+3,HEALTHBARY+2,x2+3,y2-2,BORDERCOLOUR1)
    statbar_bottom.Blit(0,y2-1)

    y2=HEALTHBARY+system.player.MAXEP-1
    y1=y2-system.player.EP
    x2=ENERGYBARX+ENERGYBARWIDTH-1
    scr.Rect(ENERGYBARX,y1,x2,y2,ENERGYBARCOLOUR,1)
    scr.Line(ENERGYBARX-1,ENERGYBARY+2,ENERGYBARX-1,y2-2,BORDERCOLOUR1)
    scr.Line(ENERGYBARX-2,ENERGYBARY+2,ENERGYBARX-2,y2-2,BORDERCOLOUR2)
    scr.Line(ENERGYBARX-3,ENERGYBARY+2,ENERGYBARX-3,y2-2,BORDERCOLOUR1)
    scr.Line(x2+1,ENERGYBARY+2,x2+1,y2-2,BORDERCOLOUR1)
    scr.Line(x2+2,ENERGYBARY+2,x2+2,y2-2,BORDERCOLOUR2)
    scr.Line(x2+3,ENERGYBARY+2,x2+3,y2-2,BORDERCOLOUR1)
    statbar_top.Blit(0,0)
    statbar_bottom.Blit(0+ENERGYBARX-4,y2-1)

    system.fnt.Print(ENERGYBARX+ENERGYBARWIDTH+20,0,"Lives: "+str(system.player.LIVES))